# pydsol
_@Author: Isabelle van Schilt_

This is the first version of a discrete simulation object library (DSOL) in Python. The main concepts of DSOL in Java are used for this library.
See https://simulation.tudelft.nl/dsol/manual/ for more information on DSOL for Java. 

The library consists of three layers: (1) **pydsol_core**, (2) **pydsol_model**, and (3) **pydsol_supplychain** _(not present yet)_. The first layer, pydsol_core, is the core of discrete event simulation including a Simulator, SimEvent, EventList, DSOLModel, Experiments etc. These components are necessary to build and analyze discrete event simulation models in Python. The second layer, pydsol_model, includes building blocks for a discrete event simulation model (DSOLModel), based on the components of pydsol_core. These are basic elements for building a discrete event simulation model, such as Entity, Source, Sink, Resource etc. These elements are useful to implement but not required. The third layer, pysdol_supplychain, includes building blocks for creating a domain-specific discrete event simulation model of supply chains, based on the components of pydsol_model. For example, ports, warehousing, inventory, orders, and money flow. An overview of the three layers of pydsol can be found in the figure below.

![](image/Overview_Pydsol_Layers.jpg)
