
"""
Created on: 22-7-2021 10:13

@author: IvS
"""
import itertools
import numpy as np

from pydsol_core.DSOLModel import DSOLModel

from pydsol_model.entity import Entity
from pydsol_model.source import Source
from pydsol_model.sink import Sink
from pydsol_model.server import Server
from pydsol_model.link import Link

from pydsol_model.server_with_resource_object import ServerWithResourceObject
from pydsol_model.server_with_capacity import ServerWithCapacity


from basic_logger import get_module_logger
logger = get_module_logger(__name__)

class MM1Model(DSOLModel):
    def __init__(self, input_parameters, **kwargs):
        super().__init__(input_parameters, **kwargs)

    def construct_model(self):
        #Reset Model
        Entity.id_iter = itertools.count(1)

        np.random.seed(self.seed)

        #Set up model
        source = Source(self.simulator)
        server = Server(self.simulator, capacity=2, distribution=None, processing_time=1)
        sink = Sink(self.simulator)

        link_1 = Link(self.simulator, source, server, 0.1)
        link_2 = Link(self.simulator, server, sink, 0.1)

        source.create_entities(Entity)

    def get_output_statistics(self):
        return None
