"""
Created on: 30-6-2021 14:38

@author: IvS
"""
import itertools
import numpy as np

import random

from example_models.first_model.statistics_manager import StatisticsManager

from basic_logger import get_module_logger
import logging
logger = get_module_logger(__name__, level=logging.INFO)

class Entity(object):
    id_iter = itertools.count()

    def __init__(self, simulator, **kwargs):
        self.id = next(self.id_iter)
        self.start_time = 1

        logger.info("Time {0:.2f}: Entity {1} is created".format(simulator.simulation_time, self.id))

        new_event = simulator.create_simevent(self.start_time, kwargs["new_source"], self, "add_time", time=3)
        simulator.schedule_event(new_event)

        StatisticsManager.final_nr_entities += 1

    def add_random_number(self, obj):
        obj.num = self.id + random.randint(1,10)
        logger.debug("ID was {0}, and adding randomness gives {1}".format(self.id, obj.num))




