"""
Created on: 9-7-2021 17:08

@author: IvS
"""

import itertools
import numpy as np

from basic_logger import get_module_logger
import logging
logger = get_module_logger(__name__, level=logging.INFO)

class FutureEntity(object):
    id_iter = itertools.count()

    def __init__(self, simulator, **kwargs):
        self.id = next(self.id_iter)
        self.quantity = round(np.random.uniform(100, 150))

        self.start_time = 30

        logger.info("Time {0:.2f}: FutureEntity {1} is created".format(simulator.simulation_time, self.id))

        new_event = simulator.create_simevent(self.start_time, kwargs["new_source"], self, "add_time", time=20)
        simulator.schedule_event(new_event)



