"""
Created on: 16-7-2021 09:51

@author: IvS
"""

import itertools
import numpy as np

from pydsol_core.DSOLModel import DSOLModel

from example_models.first_model.process import Process
from example_models.first_model.entity import Entity
from example_models.first_model.future_entity import FutureEntity
from example_models.first_model.statistics_manager import StatisticsManager

class TestModel(DSOLModel):
    def __init__(self, input_parameters, **kwargs):
        super().__init__(input_parameters, **kwargs)

    def construct_model(self):
        #Reset model
        Entity.id_iter = itertools.count()
        FutureEntity.id_iter = itertools.count()

        StatisticsManager.reset()

        np.random.seed(self.seed)

        #Schedule Warmup Event
        self.simulator.warm_up(StatisticsManager, StatisticsManager, method="reset", simulator=self.simulator)

        #Create model
        process = Process(self.simulator)
        process.create_entities(Entity, interarrival_time=self.input_parameters[0])
        process.create_entities(FutureEntity, interarrival_time=self.input_parameters[1])

    def get_output_statistics(self):
        dict_output = {"Final_Num_Entities": StatisticsManager.final_nr_entities}
        return dict_output

