"""
Created on: 30-6-2021 14:44

@author: IvS
"""

import numpy as np

from basic_logger import get_module_logger
logger = get_module_logger(__name__)


class Process(object):
    """This class is the source for process. """
    def __init__(self, simulator, **kwargs):
        self.sim = simulator
        self.kwargs=kwargs

    def add_time(self, obj, **kwargs):
        logger.debug("Old Time for {0} is {1}".format(obj.id, obj.start_time))
        obj.start_time += kwargs["time"]
        logger.debug("Start Time for Entity {0} is {1}".format(obj.id, obj.start_time))

    def create_entities(self, entity, **kwargs):
        #Add an entity
        event = self.sim.create_simevent(self.sim.simulation_time, self, entity, "__init__", simulator=self.sim,
                                         new_source=self)
        self.sim.schedule_event(event)
        relative_delay = np.random.exponential(1/kwargs["interarrival_time"])

        #Create new event for adding another entity
        new_event = self.sim.create_simevent(relative_delay, self, entity, "create_entities",
                                        interarrival_time=kwargs["interarrival_time"])
        self.sim.schedule_event(new_event)




