"""
Created on: 16-7-2021 10:27

@author: IvS
"""

from pydsol.basic_logger import get_module_logger

logger = get_module_logger(__name__)


class AbstractReplication(object):
    """The base class for a single replication of an Experiment. It constructs a stand-alone replication."""

    def __init__(self, id, start_time, warmup_time, run_length):
        """

        Parameters
        ----------
        id: int
            the id of the replication; should be unique within the experiment.
        start_time: int
            the start time as a time object.
        warmup_time: int
            the warmup period, included in the runlength.
        run_length: int
            the total length of the run, including the warm-up period.
        """
        self.id = id
        self.start_time = start_time
        self.warmup_time = warmup_time
        self.run_length = run_length

        logger.debug("Replication {0} with run time {1} is created".format(self.id, self.run_length))
