"""
Created on: 16-7-2021 09:12

@author: IvS
"""

from pydsol.basic_logger import get_module_logger

logger = get_module_logger(__name__)


class DSOLModel(object):
    """The discrete event simulation model object is defined. The DSOLModel now knows its simulator. Through the Simulator,
    the Replication can be requested and through that the Experiment under which the simulation is running. """
    def __init__(self, input_parameters, **kwargs):
        """

        Parameters
        ----------
        input_parameters:
            input parameters of the model
        **kwargs:
            remaining keywords arguments
        """
        self.input_parameters = input_parameters
        self.simulator = object()

        self.seed = self.set_default_seed()

    def construct_model(self):
        """This function construct a model on a simulator. """
        raise NotImplementedError

    def get_output_statistics(self):
        """This function ensures that there are output statistics for each run."""
        raise NotImplementedError

    @staticmethod
    def set_default_seed():
        """This function sets a default seed value of 1."""
        return 1
