"""
Created on: 16-7-2021 10:44

@author: IvS
"""

from pydsol.basic_logger import get_module_logger
from pydsol.pydsol_core.AbstractReplication import AbstractReplication

logger = get_module_logger(__name__)


class ExperimentReplication(AbstractReplication):
    """This class defines a single replication belonging to an experiment. """
    def __init__(self, id, start_time, warmup_time, run_length, experiment):
        """

        Parameters
        ----------
        id: int
            the id of the replication; should be unique within the experiment.
        start_time: int
            the start time as a time object.
        warmup_time: int
            the warmup period, included in the runlength.
        run_length: int
            the total length of the run, including the warm-up period.
        experiment: object
            Experiment object
        """
        super().__init__(id, start_time, warmup_time, run_length)
        self.experiment = experiment
