"""
Created on: 11-8-2021 11:04

@author: IvS
"""

from pydsol.pydsol_model.entity import Entity

from pydsol.basic_logger import get_module_logger
logger = get_module_logger(__name__)


class Vehicle(Entity):
    """This class defines a vehicle in a discrete event simulation model, and is a subclass of Entity. A vehicle is an
    entity of which other entities can be transported. The entities on the vehicle are tracked by a list."""
    def __init__(self, simulator, speed, **kwargs):
        """

        Parameters
        ----------
        simulator: Simulator object
            simulator of the model.
        speed:
            speed of the vehicle.
        kwargs:
             kwargs are the keyword arguments that are used to expand the vehicle class.
        """
        super().__init__(simulator, speed, **kwargs)
        self.entities_on_vehicle = []
