"""
Created on: 23-8-2021 10:36

@author: IvS
"""

import pytest

from pydsol.pydsol_core.SimEvent import SimEvent


def test_execute(mocker):
    mock_execution_time = 1
    mock_source = mocker.Mock()
    mock_target = mocker.Mock()

    # Test case 1 - gives AttributeError with __init__
    mock_method_name = "__init__"
    event = SimEvent(mock_execution_time, mock_source, mock_target, mock_method_name)
    with pytest.raises(AttributeError):
        event.execute()

    # Test case 2 - gives no AttributeError with __init__
    mock_target_class = mocker.Mock
    event = SimEvent(mock_execution_time, mock_source, mock_target_class, mock_method_name)
    event.execute()

    # Test case 3 - gives no AttributeError with other method name
    mock_method_name = "other"
    event = SimEvent(mock_execution_time, mock_source, mock_target, mock_method_name)
    event.execute()

    # Test case 4 - gives AttributeError with other method
    del mock_source.other
    event = SimEvent(mock_execution_time, mock_source, mock_target, mock_method_name)
    with pytest.raises(AttributeError):
        event.execute()


if __name__ == '__main__':
    pytest.main()
