from stylized_supply_chain_model.model_elements.product import Product
from pydsol.pydsol_core.Simulator import Simulator
from pydsol.pydsol_model.sink import Sink

from stylized_supply_chain_model.model_elements.statistic_manager import StatisticManager


class Customer(Sink, StatisticManager):
    def __init__(self, simulator: Simulator, **kwargs):
        super().__init__(simulator, **kwargs)
        StatisticManager.__init__(self)
        if "type" in kwargs:
            self.type = kwargs['type']
            self.name = self.name + " " + self.type

        self.entities_of_system = []

    def enter_input_node(self, entity: Product):
        self.quantity += entity.quantity
        super().enter_input_node(entity)

    def destroy_entity(self, entity: Product):
        entity.time_in_system = self.simulator.simulation_time - entity.start_time
        # Add value to list
        self.entities_of_system.append(entity)
        self.quantity -= entity.quantity
        super().destroy_entity(entity)
