"""
Created on: 14-2-2022 09:57

@author: IvS
"""

from pydsol.pydsol_model.link import Link

from pydsol.basic_logger import get_module_logger
logger = get_module_logger(__name__)


class SeaLink(Link):
    """This class defines a link at sea"""
    def __init__(self, simulator, origin, destination, length, **kwargs):
        super().__init__(simulator, origin, destination, length, **kwargs)

    def enter_link(self, entity, **kwargs):
        distance_travelled = 0
        days_to_travel = 0

        while distance_travelled < self.length:
            distance_per_day = entity.speed_distribution(*entity.speed_values)*24

            distance_to_travel = self.length - distance_travelled
            if distance_per_day > distance_to_travel:
                distance_travelled += distance_to_travel
                days_to_travel += max(0, (distance_to_travel/distance_per_day))
            else:
                distance_travelled += distance_per_day
                days_to_travel += 1

        relative_delay = days_to_travel #per day

        event = self.simulator.create_simevent(relative_delay, self, entity, "exit_link")
        self.simulator.schedule_event(event)
