import numpy as np

from pydsol.pydsol_model.entity import Entity


class Product(Entity):
    def __init__(self, simulator, **kwargs):
        super().__init__(simulator, **kwargs)

        self.quantity = round(np.random.uniform(100, 150) * self.kwargs["interarrival_time"], 0)
        self.start_time = self.simulator.simulation_time
        self.time_in_system = 0
        self.start_international_transport = 0
        self.start_wholesales_distributor = 0
        self.international_transport_time = 0
        self.wholesales_distributor_time = 0

    def __repr__(self):
        return self.name
