import numpy as np

from stylized_supply_chain_model.model_elements.vehicles.ferry import Ferry
from pydsol.pydsol_model.server import Node

from pydsol.basic_logger import get_module_logger

logger = get_module_logger(__name__)


class TransferLocation(Node):
    def __init__(self, simulator, **kwargs):
        super().__init__(simulator, **kwargs)
        self.location = kwargs['location']
        self.name = self.name + " " + self.location

    def enter_input_node(self, entity, **kwargs):
        if isinstance(entity, Ferry):
            vehicle = entity
            for entity in vehicle.entities_on_vehicle:
                logger.info("Time {0:.2f}: {1} loaded off {2} at {3}".format(
                    self.simulator.simulation_time, entity.name, vehicle.name, self.name))
                if self.location == "Spain":
                    entity.speed = np.random.normal(entity.speed + 20)

                self.exit_output_node(entity)
                # To reduce number of objects in model
            del vehicle
        else:
            self.exit_output_node(entity)
